configuring ibmnas driver in multi-backend environment fails due to uninitialized nas options

Bug #1298279 reported by Sasikanth Eda on 2014-03-27
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Cinder
High
Sasikanth Eda

Bug Description

Hi,

when configured in multi-back mode using ibmnas driver, cinder service throws below error;

2014-03-27 15:15:37.154 DEBUG stevedore.extension [-] found extension EntryPoint.parse('nova.openstack.common.notifier.rpc_notifier2 = oslo.messaging.notify._impl_messaging:MessagingV2Driver') from (pid=5204) _load_plugins /opt/stack/stevedore/stevedore/extension.py:156
2014-03-27 15:15:39.207 CRITICAL cinder [-] NoSuchOptError: no such option in group storage1: nas_ip

2014-03-27 15:15:39.207 TRACE cinder Traceback (most recent call last):
2014-03-27 15:15:39.207 TRACE cinder File "/usr/local/bin/cinder-volume", line 7, in <module>
2014-03-27 15:15:39.207 TRACE cinder execfile(__file__)
2014-03-27 15:15:39.207 TRACE cinder File "/opt/stack/cinder/bin/cinder-volume", line 66, in <module>
2014-03-27 15:15:39.207 TRACE cinder service_name=backend)
2014-03-27 15:15:39.207 TRACE cinder File "/opt/stack/cinder/cinder/service.py", line 202, in create
2014-03-27 15:15:39.207 TRACE cinder service_name=service_name)
2014-03-27 15:15:39.207 TRACE cinder File "/opt/stack/cinder/cinder/service.py", line 90, in __init__
2014-03-27 15:15:39.207 TRACE cinder *args, **kwargs)
2014-03-27 15:15:39.207 TRACE cinder File "/opt/stack/cinder/cinder/volume/manager.py", line 208, in __init__
2014-03-27 15:15:39.207 TRACE cinder host=self.host)
2014-03-27 15:15:39.207 TRACE cinder File "/opt/stack/cinder/cinder/openstack/common/importutils.py", line 38, in import_object
2014-03-27 15:15:39.207 TRACE cinder return import_class(import_str)(*args, **kwargs)
2014-03-27 15:15:39.207 TRACE cinder File "/opt/stack/cinder/cinder/volume/drivers/ibm/ibmnas.py", line 64, in __init__
2014-03-27 15:15:39.207 TRACE cinder self.configuration.san_ip = self.configuration.nas_ip
2014-03-27 15:15:39.207 TRACE cinder File "/opt/stack/cinder/cinder/volume/configuration.py", line 80, in __getattr__
2014-03-27 15:15:39.207 TRACE cinder return getattr(self.local_conf, value)
2014-03-27 15:15:39.207 TRACE cinder File "/opt/stack/oslo.config/oslo/config/cfg.py", line 2226, in __getattr__
2014-03-27 15:15:39.207 TRACE cinder return self._conf._get(name, self._group)
2014-03-27 15:15:39.207 TRACE cinder File "/opt/stack/oslo.config/oslo/config/cfg.py", line 1964, in _get
2014-03-27 15:15:39.207 TRACE cinder value = self._do_get(name, group, namespace)
2014-03-27 15:15:39.207 TRACE cinder File "/opt/stack/oslo.config/oslo/config/cfg.py", line 1982, in _do_get
2014-03-27 15:15:39.207 TRACE cinder info = self._get_opt_info(name, group)
2014-03-27 15:15:39.207 TRACE cinder File "/opt/stack/oslo.config/oslo/config/cfg.py", line 2106, in _get_opt_info
2014-03-27 15:15:39.207 TRACE cinder raise NoSuchOptError(opt_name, group)
2014-03-27 15:15:39.207 TRACE cinder NoSuchOptError: no such option in group storage1: nas_ip
2014-03-27 15:15:39.207 TRACE cinder

This is caused due to missing of appending the nas options (self.configuration.append_config_values(nas_opts))

Jay Bryant (jsbryant) wrote :

Sasikanth,

Are you working on a fix for this?

Changed in cinder:
importance: Undecided → Medium

Fix proposed to branch: master
Review: https://review.openstack.org/83425

Changed in cinder:
assignee: nobody → Sasikanth Eda (sasikanth)
status: New → In Progress
Jay Bryant (jsbryant) wrote :

Making this a high priority as it should be a small fix but notable impact. Would be good to get this fixed in Icehouse.

Changed in cinder:
importance: Medium → High
Mike Perez (thingee) wrote :

We'll see if we end up with another RC, otherwise backport.

Changed in cinder:
milestone: none → next
Mike Perez (thingee) on 2014-03-29
Changed in cinder:
milestone: next → none
tags: added: icehouse-backport-potential
tags: added: drivers ibmnas
tags: added: icehouse-rc-potential
removed: icehouse-backport-potential
Changed in cinder:
milestone: none → icehouse-rc2

Reviewed: https://review.openstack.org/83425
Committed: https://git.openstack.org/cgit/openstack/cinder/commit/?id=adb43dab7072a7e452710ac5db346e9a2c99993f
Submitter: Jenkins
Branch: master

commit adb43dab7072a7e452710ac5db346e9a2c99993f
Author: Sasikanth <email address hidden>
Date: Thu Mar 27 20:44:50 2014 +0530

    Append nas_opts to IBMNAS_NFSDriver configuration

    'nas_opts' were added in the NFS Driver (nfs.py), but were not appended
    to the IBMNAS driver configuration, causing failure with the multi-backend
    configuration of driver.

    Adding the missing configuration.

    Change-Id: I55727566d03573908750d01ae1345c4b6276f131
    Closes-Bug: #1298279

Changed in cinder:
status: In Progress → Fix Committed

Reviewed: https://review.openstack.org/85465
Committed: https://git.openstack.org/cgit/openstack/cinder/commit/?id=bc916e9da0b5a65ac999fe6d2539d845fddfa276
Submitter: Jenkins
Branch: milestone-proposed

commit bc916e9da0b5a65ac999fe6d2539d845fddfa276
Author: Sasikanth <email address hidden>
Date: Thu Mar 27 20:44:50 2014 +0530

    Append nas_opts to IBMNAS_NFSDriver configuration

    'nas_opts' were added in the NFS Driver (nfs.py), but were not appended
    to the IBMNAS driver configuration, causing failure with the multi-backend
    configuration of driver.

    Adding the missing configuration.

    Change-Id: I55727566d03573908750d01ae1345c4b6276f131
    Closes-Bug: #1298279
    (cherry picked from commit adb43dab7072a7e452710ac5db346e9a2c99993f)

Changed in cinder:
status: Fix Committed → Fix Released
Thierry Carrez (ttx) on 2014-04-17
Changed in cinder:
milestone: icehouse-rc2 → 2014.1
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers